/*
  File name        : calloc.c
  Date of creation : 15/6/2009
  Version          : 1.0
  Copyright        : Soft'n'design
  Author           : Laurent Mazet <mazet@softndesign.org>

  Description      : This file contains tests for malloc debuggers

  History          :
  - initial version
*/

/* depend: libcalloc.so */
/* cflags: */
/* linker: -lcalloc */

#include <assert.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>

#include "../calloc.h"

#define N 30

int main (int argc, char *argv[]) 
{

    /* process arguments */
    if (argc > 1) {
        printf ("usage: %s\n", argv[0]);
        exit (1);
    }

    char *ctab = (char *) malloc(N * sizeof (char));
    ctab[N] = 1;
    free (ctab);

    int *itab = (int *) malloc(N * sizeof (int));
    itab[-1] = 2;
    free (itab);

    short *stab = (short *) malloc(N * sizeof (short));
    stab[1] = 2;
    free (stab);

    float *ftab = (float *) malloc(N * sizeof (float));
    ftab[-1] = ftab[N] = 3;

    char *ctab2 = (char *) malloc(1 * sizeof (char));
    ctab2[-1] = 4;
    ctab2 = (char *) realloc(ctab2, N * sizeof (char));
    ctab2[N] = 5;

    itab = (int *) malloc(N * sizeof (int));
    itab[-1] = 2;

    return 0;
}

/* test: MEMORY_ALLOCATION_=0 {} */
/* test: MEMORY_ALLOCATION_=1 {} */
/* test: MEMORY_ALLOCATION_=2 {} */
/* test: MEMORY_ALLOCATION_=y {} */
/* test: MEMORY_ALLOCATION_=t {} */

/* vi:set tabstop=4 expandtab shiftwidth=4: this line set vi mode */
